unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DBTables, Db, Provider, BdeProv, DBClient, Grids, DBGrids,
  ClientDataSetQuery, StdCtrls, ExtCtrls, DBCtrls;

type
  TForm1 = class(TForm)
    DataSource1: TDataSource;
    ClientDataSetQuery1: TClientDataSetQuery;
    Database1: TDatabase;
    DBGrid1: TDBGrid;
    ClientDataSetQuery1CustNo: TFloatField;
    ClientDataSetQuery1Company: TStringField;
    ClientDataSetQuery1Addr1: TStringField;
    ClientDataSetQuery1Addr2: TStringField;
    ClientDataSetQuery1City: TStringField;
    ClientDataSetQuery1State: TStringField;
    ClientDataSetQuery1Zip: TStringField;
    ClientDataSetQuery1Country: TStringField;
    ClientDataSetQuery1Phone: TStringField;
    ClientDataSetQuery1FAX: TStringField;
    ClientDataSetQuery1TaxRate: TFloatField;
    ClientDataSetQuery1Contact: TStringField;
    ClientDataSetQuery1LastInvoiceDate: TDateTimeField;
    ClientDataSetQuery2: TClientDataSetQuery;
    ClientDataSetQuery2OrderNo: TFloatField;
    ClientDataSetQuery2CustNo: TFloatField;
    ClientDataSetQuery2SaleDate: TDateTimeField;
    ClientDataSetQuery2ShipDate: TDateTimeField;
    ClientDataSetQuery2EmpNo: TIntegerField;
    ClientDataSetQuery2ShipToContact: TStringField;
    ClientDataSetQuery2ShipToAddr1: TStringField;
    ClientDataSetQuery2ShipToAddr2: TStringField;
    ClientDataSetQuery2ShipToCity: TStringField;
    ClientDataSetQuery2ShipToState: TStringField;
    ClientDataSetQuery2ShipToZip: TStringField;
    ClientDataSetQuery2ShipToCountry: TStringField;
    ClientDataSetQuery2ShipToPhone: TStringField;
    ClientDataSetQuery2ShipVIA: TStringField;
    ClientDataSetQuery2PO: TStringField;
    ClientDataSetQuery2Terms: TStringField;
    ClientDataSetQuery2PaymentMethod: TStringField;
    ClientDataSetQuery2ItemsTotal: TCurrencyField;
    ClientDataSetQuery2TaxRate: TFloatField;
    ClientDataSetQuery2Freight: TCurrencyField;
    ClientDataSetQuery2AmountPaid: TCurrencyField;
    DBGrid2: TDBGrid;
    DataSource2: TDataSource;
    DBNavigator1: TDBNavigator;
    DBNavigator2: TDBNavigator;
    procedure ClientDataSetQuery1AfterPost(DataSet: TDataSet);
    procedure ClientDataSetQuery1UpdateError(Sender: TObject;
      DataSet: TClientDataSet; E: EUpdateError; UpdateKind: TUpdateKind;
      var Response: TResolverResponse);
    procedure ClientDataSetQuery1AfterDelete(DataSet: TDataSet);
    procedure ClientDataSetQuery1AfterCancel(DataSet: TDataSet);
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure DataSource1DataChange(Sender: TObject; Field: TField);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

uses
    BDE;

procedure TForm1.ClientDataSetQuery1AfterPost(DataSet: TDataSet);
begin
     with DataSet as TClientDataSetQuery do
         if ApplyUpdates(-1)>0 then
         begin
            Edit;
            Fields[0].Value:=Fields[0].Value;
            SysUtils.Abort;
         end;
end;

procedure TForm1.ClientDataSetQuery1UpdateError(Sender: TObject;
  DataSet: TClientDataSet; E: EUpdateError; UpdateKind: TUpdateKind;
  var Response: TResolverResponse);
begin
     ShowMessage((Sender as TProvider).Name+'-'+E.Message);
end;

procedure TForm1.ClientDataSetQuery1AfterDelete(DataSet: TDataSet);
begin
     with DataSet as TClientDataSetQuery do
         if ApplyUpdates(-1)>0 then
         begin
            CancelUpdates;
            Refresh;  
            SysUtils.Abort;
         end;
end;

procedure TForm1.ClientDataSetQuery1AfterCancel(DataSet: TDataSet);
begin
     (DataSet as TClientDataSetQuery).CancelUpdates;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
     ClientDataSetQuery2.Open;
     ClientDataSetQuery1.Open;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
     ShowMessage(IntToStr(ClientDataSetQuery2.RecordCount));
end;

procedure TForm1.DataSource1DataChange(Sender: TObject; Field: TField);
begin
     if (Field=nil) and (ClientDataSetQuery2.Active) then
        ClientDataSetQuery2.First; // to fix an apparent bug of Delphi 4 not refreshing properly detail records
end;

end.
